/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.4a Advanced
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 29.12.2010
Author  : sersne
Company : home
Comments: 


Chip type               : ATmega64
Program type            : Application
AVR Core Clock frequency: 16,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 1024
*****************************************************/

#include <mega64.h>

#include <delay.h> 
#include <stdlib.h>
#include <stdio.h>

//  8x8      8x14

#include "font8x8.h"
#include <l020b_lcd.h>

#include <io.h>
#include <math.h> 


// 1 Wire Bus functions
#asm
   .equ __w1_port=0x18
   .equ __w1_bit=7
#endasm

#include <1wire.h>

// DS1820 temperature sensor functions
#include <ds1820.h>
#include <delay.h>
// Declare your global variables here

#define UP PINC.0
#define LEFT PINC.2
#define RIGHT PINC.1
#define DOWN PINC.4
#define MENU PINC.3

// SPI functions
#include <spi.h>

unsigned char sec;

unsigned char show_data;

int T,X1,X2,X3; 

unsigned char focus;


//dat[0] - ten hours
//dat[1] - one hours
//dat[2] - ten minutes
//dat[3] - one minutes
//dat[4] - week
//dat[5] - ten day
//dat[6] - one day
//dat[7] - month
//dat[8] - ten year
//dat[9] - one year
unsigned char dat[10];


unsigned char time;
unsigned char seconds;

//unsigned int fillcolor;
//char buffer[24];
//unsigned int i;

unsigned char *month[12] = 
{       
" ",
"",
"   ",
" ",
"    ",
"   ",
"   ",
" ",
"",
"",
" ",
""
};                        


unsigned char *week[7] = 
{       
"",
"    ",
"      ",
"    ",
"    ",
"    ",
""
};

unsigned char *menu[2] =
{
"    ",
"MENU"
};


// Declare your global variables here

void set_month(char a, char b, char c, char d)
{

        if ((a == c) && (b == d))
        {
           dat[5] = 0;
           dat[6] = 1;        
           
           dat[7] = dat[7] + 1; // 
        }
}   


void set_h_day(char a, char b, char c)
{

        if (dat[7] == a)  // 
        {
                if ((++dat[5] > b)&&(dat[6] > c))
                {
                        dat[5] = b;
                        dat[6] = c;
                }               
                else
                {
                        if (dat[5] > b) dat[5] = b;
                }
        }



}   


void set_l_day(char a, char b, char c)
{

        if (dat[7] == a)  // 
        {                          
                dat[6] = dat[6] + 1;
                if ((dat[5] > b)&&(dat[6] > c))
                {
                        dat[5] = b;
                        dat[6] = c;
                }               
                else
                {
                        if ((dat[6] > 9)&&(dat[5] < b)) dat[6] = 9;
                }
        }



}   

/*
==============================================================================================
           Timer 0
==============================================================================================
*/   

interrupt [TIM0_OVF] void timer0_ovf_isr (void)
{
TCNT0=0x64;

        if (++time == 150)
        {               
          time = 0;
          
                if (MENU == 0)
                {
                        if (show_data == 0)
                        {
                                show_data = 1;
                                put_string(0,70,menu[0],BLACK);                                                       
                        }
                        else
                        {
                                show_data = 0;                           
                                put_string(0,70,menu[1],BLACK);
                        }
                }



                if (show_data == 0)
                {




                //dat[0] - ten hours
                //dat[1] - one hours
                //dat[2] - ten minutes
                //dat[3] - one minutes
                //dat[4] - week
                //dat[5] - ten day
                //dat[6] - one day
                //dat[7] - month
                //dat[8] - ten year
                //dat[9] - one year



                        if (LEFT == 0) 
                        {
                                focus = focus + 1;
                                if (focus == 9) focus = 8;   
                        }

                        if (RIGHT == 0) 
                        {
                                focus = focus - 1;
                                if (focus == 0xFF) focus = 0;   
                        }

                        if (UP == 0) 
                        {
                                if (focus == 0) if (++dat[0] == 3) dat[0] = 2;

                                if (focus == 1) 
                                {
                                        if (++dat[1] == 10) dat[1] = 9;                                
                                        
                                        if (dat[0] >= 2)
                                        {
                                             if (dat[1] > 3) dat[1] = 3;
                                        }
                                }


                                if (focus == 2) if (++dat[2] >= 6) dat[2] = 5;

                                if (focus == 3) if (++dat[3] == 10) dat[3] = 9;
                                
                                
                                if (focus == 4) if (++dat[4] >= 8) dat[4] = 7;


                                if (focus == 5) if (++dat[7] >= 12) dat[7] = 11;                                

                                if (focus == 6) 
                                {

                                        set_h_day(0,3,1);  //  
                                        set_h_day(1,2,8);  //  
                                        set_h_day(2,3,1);  //  
                                        set_h_day(3,3,0);  //  
                                        set_h_day(4,3,1);  //  
                                        set_h_day(5,3,0);  //  
                                        set_h_day(6,3,1);  //  
                                        set_h_day(7,3,1);  //  
                                        set_h_day(8,3,0);  //  
                                        set_h_day(9,3,1);  //  
                                        set_h_day(10,3,0);  //  
                                        set_h_day(11,3,1);  //   

                                }


                                if (focus == 7) 
                                {

                                        set_l_day(0,3,1);  //  
                                        set_l_day(1,2,8);  //  
                                        set_l_day(2,3,1);  //  
                                        set_l_day(3,3,0);  //  
                                        set_l_day(4,3,1);  //  
                                        set_l_day(5,3,0);  //  
                                        set_l_day(6,3,1);  //  
                                        set_l_day(7,3,1);  //  
                                        set_l_day(8,3,0);  //  
                                        set_l_day(9,3,1);  //  
                                        set_l_day(10,3,0);  //  
                                        set_l_day(11,3,1);  //   

                                }


                                if (focus == 8) 
                                {
                                        if (++dat[9] > 9) 
                                        {
                                                dat[9] = 0;
                                                
                                                if (++dat[8] > 2) dat[8] = 2;
                                                

                                        }
                                }
                        }






                        if (DOWN == 0) 
                        {
                                if (focus == 0) if (--dat[0] == 0xFF) dat[0] = 0;

                                if (focus == 1) if (--dat[1] == 0xFF) dat[1] = 0;                                

                                if (focus == 2) if (--dat[2] == 0xFF) dat[2] = 0;

                                if (focus == 3) if (--dat[3] == 0xFF) dat[3] = 0;
                                
                                if (focus == 4) if (--dat[4] == 0xFF) dat[4] = 0;

                                if (focus == 5) if (--dat[7] == 0xFF) dat[7] = 0;                                
                                        
                                if (focus == 6) if (--dat[5] == 0xFF) dat[5] = 0;

                                if (focus == 7) if (--dat[6] == 0xFF) dat[6] = 0;

                                if (focus == 8) 
                                {
                                        if (--dat[9] == 0xFF) 
                                        {
                                                dat[9] = 0;

                                                if (--dat[8] == 0xFF) dat[8] = 0;
                                        }
                                }
                        }

                        if (focus == 0)
                        {                        
                                put_char(0,1,dat[0] + 48, RED);
                        }
                        else
                        {
                                put_char(0,1,dat[0] + 48,BLACK);                        
                        }

                        if (focus == 1)
                        {                        

                                put_char(9,1,dat[1] + 48,RED);
                        }
                        else
                        {
                                put_char(9,1,dat[1] + 48,BLACK);                        
                        }                                   
                        
                        
                                put_string(18,1,":",BLACK);
                                      
                        if (focus == 2)
                        {                        
                                put_char(27,1,dat[2] + 48,RED);
                        }
                        else
                        {
                                put_char(27,1,dat[2] + 48,BLACK);                        
                        }                                    
                        
                        if (focus == 3)
                        {                        
                                put_char(36,1,dat[3] + 48,RED);
                        }
                        else
                        {
                                put_char(36,1,dat[3] + 48,BLACK);                        
                        }                                    

                        if (focus == 4)
                        {                        
                                put_string(56,1,week[dat[4]],RED);
                        }
                        else
                        {
                                put_string(56,1,week[dat[4]],BLACK);                        
                        }                                       

                        if (focus == 6)
                        {                        
                                put_char(0,20,dat[5] + 48,RED);                        
                        }
                        else
                        {                        
                                put_char(0,20,dat[5] + 48,BLACK);
                        }                                    
                        
                        if (focus == 7)
                        {                        
                                put_char(9,20,dat[6] + 48,RED);                        
                        }
                        else
                        {
                                put_char(9,20,dat[6] + 48,BLACK);
                        }                                


                        if (focus == 5)
                        {                        
                                put_string(22,20,month[dat[7]],RED);                        
                        }
                        else
                        {
                                put_string(22,20,month[dat[7]],BLACK);
                        }


                        if (focus == 8)
                        {                        
                                put_char(82,20,50,RED);
                                put_char(91,20,48,RED);
                                put_char(100,20,dat[8] + 48,RED);
                                put_char(109,20,dat[9] + 48,RED);                        }                            
                        else
                        {
                                put_char(82,20,50,BLACK);                        
                                put_char(91,20,48,BLACK);
                                put_char(100,20,dat[8] + 48,BLACK);
                                put_char(109,20,dat[9] + 48,BLACK);
                        }                                     
                }
        }
}




interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{           


        TCNT1H=0xC2;
        TCNT1L=0xF7;



        
        sec++;
        if (sec >= 60) 
        {
        sec = 0;

           dat[3] = dat[3]+1;
           if (dat[3] >= 10) 
           {
                dat[3] = 0; //  10  -> 0
                dat[2] = dat[2] + 1;

                if (dat[2] >= 6) 
                {
                   dat[2] = 0;
                   dat[1] = dat[1] + 1;                            
                   
                   if (dat[1] >= 10) 
                   {
                     dat[1] = 0;
                     dat[0] = dat[0] + 1;
                   }

                   if (dat[0] >= 2) 
                   {

                     if (dat[1] >= 4) 
                     //    (24 )
                     {
                         dat[1] = 0;
                         dat[0] = 0;
                         dat[4] = dat[4] + 1;
                         
                         if (dat[4] >= 7)  // 
                         {
                            dat[4] = 0;
                         }
                        
                         dat[6] = dat[6] + 1;
                         if (dat[6] >= 10)
                         //  10 
                         {
                            dat[6] = 0;           //  
                            dat[5] = dat[5] + 1;  //  
                         }

                         //   
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(2,8,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  

                         
                         if (dat[7] >= 12)  // 12  
                         {
                             dat[7] = 0;
                             
                             dat[9] = dat[9] + 1;
                             if (dat[9] >= 10)
                             {
                                dat[9] = 0;
                                dat[8] = dat[8] + 1;
                                
                                if (dat[8] == 10) dat[8] = 0;
                             }
                         }
                     }
                   }
                }
           }
        }
                    
        
        
        
        if (show_data == 1)
        {


            switch (++seconds)
            {
                case 5: seconds = 0;



                     T =  ds1820_temperature_10(0)/10;     // read DS1820 every 5 sec.  



                     //    
                     X3=X2;
                     X2=T;
                     if (X2==X3) 
                     {

                           X1=T;
                     }

                     T=(X1);

                     put_string(50, 50, "()",BLACK); 

                     if(T<0)
                     {       


                            // lcd_chr(60, 50, 3); //  
                                
                             T = abs(T);   // get only amplitude
                             
                             put_char(30, 50,(T%10)+48,BLACK);
                             

                                     
                             if ((T/10) == 0)
                             {               

                                     put_string(10,50,"-",BLACK);  // put -
                                     put_char(20,50,0,BLACK);
                        
                             }
                             else
                             {

                                     put_string(10,50,"-",BLACK);    // put -
                                     put_char(20,50,(T/10)+48,BLACK);                                     

                             }
                             
                     }
                     else
                     {

                               
                             T = abs(T);   // get only amplitude
                             
                             put_char(30, 50,(T%10)+48,BLACK);
                                     
                             if ((T/10) == 0)
                             {                                   
                                     put_char(10,50,0,BLACK);                             
                                     put_char(20,50,0,BLACK);
                             }
                             else
                             {
                                     put_char(20,50,(T/10)+48,BLACK);
                             }
                             

                     }                   


            }




                //dat[0] - ten hours
                //dat[1] - one hours
                //dat[2] - ten minutes
                //dat[3] - one minutes
                //dat[4] - week
                //dat[5] - ten day
                //dat[6] - one day
                //dat[7] - month
                //dat[8] - ten year
                //dat[9] - one year


                put_char(0,1,dat[0] + 48,BLACK);
                put_char(9,1,dat[1] + 48,BLACK);

                put_string(18,1,":",BLACK);

                put_char(27,1,dat[2] + 48,BLACK);
                put_char(36,1,dat[3] + 48,BLACK);

                put_string(56,1,week[dat[4]],BLACK);

                put_char(0,20,dat[5] + 48,BLACK);
                put_char(9,20,dat[6] + 48,BLACK);

                put_string(22,20,month[dat[7]],BLACK);

                put_char(82,20,50,BLACK);
                put_char(91,20,48,BLACK);

                put_char(100,20,dat[8] + 48,BLACK);
                put_char(109,20,dat[9] + 48,BLACK);

        }


}



void main(void)
{
// Declare your local variables here





// Input/Output Ports initialization
// Port A initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTA=0xFF;
DDRA=0xFF;

// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTB=0xFF;
DDRB=0xFF;

// Port C initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTC=0xFF;
DDRC=0x00;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTD=0xFF;
DDRD=0xFF;

// Port E initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTE=0xFF;
DDRE=0xFF;

// Port F initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTF=0xFF;
DDRF=0xFF;

// Port G initialization
// Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State4=1 State3=1 State2=1 State1=1 State0=1 
PORTG=0x1F;
DDRG=0x1F;

//  Timer 0
//TCCR0=0x00;
TCCR0=0x05;
TCNT0=0x64;         

//  Timer 1
TCCR1B=0x05;
TCCR1A=0x00;
TCNT1H=0xC2;
TCNT1L=0xF7;
OCR1BL=0x00;
OCR1BH=0x00;
OCR1AL=0x00;
OCR1AH=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// Timer/Counter 3 initialization
// Clock source: System Clock
// Clock value: Timer3 Stopped
// Mode: Normal top=FFFFh
// OC3A output: Discon.
// OC3B output: Discon.
// OC3C output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer3 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR3A=0x00;
TCCR3B=0x00;
TCNT3H=0x00;
TCNT3L=0x00;
ICR3H=0x00;
ICR3L=0x00;
OCR3AH=0x00;
OCR3AL=0x00;
OCR3BH=0x00;
OCR3BL=0x00;
OCR3CH=0x00;
OCR3CL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: Off
// INT7: Off
EICRA=0x00;
EICRB=0x00;
EIMSK=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK = 0b101;
ETIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;




// spi
SPCR=0x50;
SPSR=0x01;




        //dat[0] - ten hours
        //dat[1] - one hours
        //dat[2] - ten minutes
        //dat[3] - one minutes
        //dat[4] - week
        //dat[5] - ten day
        //dat[6] - one day
        //dat[7] - month
        //dat[8] - ten year
        //dat[9] - one year
          dat[0] = 0;
          dat[1] = 0;
          dat[2] = 0;
          dat[3] = 0;
          dat[4] = 1;
          dat[5] = 0;
          dat[6] = 7;
          dat[7] = 0;
          dat[8] = 1;
          dat[9] = 1;




      X1=0;
      X2=0;
      X3=0;	               
      T = 0;

seconds = 0;

focus = 0;

show_data = 1;

time = 0;

// 1 Wire Bus initialization
   w1_init();


#asm("sei")


LS020_lcd_init();




srand(120);

lcd_cputpixel(2,174, BLUE);


while (1)
{

//                delay_ms(100); 
//                put_string(1, 1, text, BLACK);

}
}
